/*
$Log: ymail.cc,v $
Revision 1.3  1999/01/10 15:19:34  serg
  Sinix
CVS:
CVS:

Revision 1.2  1998/04/29 00:34:21  serg
    -Wall  
CVS:
CVS:

Revision 1.1  1998/04/15 18:38:39  serg
CVS:
CVS:

*/
#include <stdio.h>

#ifdef DMALLOC
#include <dmalloc.h>
#endif

#include <listbox.h>
#include "ymail.h"
#include "yui.h"
#include "hashcode.h"

YMail::YMail( const char *email ) :
		Dialog( scrRect(), new Lang( "Mail", "" ), 0, new Lang( "Mail window"," " ) ),
		mail_text(10,10), mail_edit(0)
{
   addr_to[ 0 ] = addr_from[ 0 ] = addr_cc[ 0 ] = subj[ 0 ] = 0;
   addr_to[127] = addr_from[127] = addr_cc[255] = subj[127] = 0;

   put( 0, 1, lang( "To:", ":" ) );

   put( 1, 1, lang( "Subject:", ":" ) );
   if ( email )
      strcpy( addr_to, email );
   inputLine *il = new inputLine( Point(0,10), addr_to, addr_to, 40, (email && email[0]) ? 0 : 127 );
   insert( il );

   il = new inputLine( Point(1,10), subj, subj, 40, 127 );
   insert( il );

   mail_edit = new Edit( &mail_text, "Message", Rect( 3, -1, rect.b.y-5, rect.b.x ) );
   insert( mail_edit );
   mail_edit->init();

   button *bt = new button( Point(rect.b.y-3, (Screen::Columns-20)/3),  lang("  Send  ", "  "), HASH_cmSend );
   insert( bt );
   bt = new button( Point(rect.b.y-3, (Screen::Columns-20)/3*2+10), lang(" Cancel ", "  "), HASH_cmClose );
   insert( bt );
   select(1);
}

long YMail::handleKey( long key, void *&ptr )
{
   if ( key == kbTab )
      key = HASH_cmNext;
   key = Dialog::handleKey( key, ptr );
   if ( key == HASH_cmOK )
      return 0;
   if ( key == HASH_cmSend )
    {
      static char tmpfile[256];
      tmpfile[0] = 0;
      char *mail_command;
      tmpnam( tmpfile );
      FILE *f;
      if ( !tmpfile[0] || !(f=fopen( tmpfile, "w" ) ) )
	 goto bad_file;
      int i, status;
      for( i=0; i<count; i++ )
	 ((getobj*)items[i])->accept();
      mail_edit->saveCollection();

      for( i=0; i < mail_text.getCount(); i++ )
       {
	 fputs( (char*)mail_text.at(i), f );
	 fputs( "\n", f );
       }
      fclose( f );
      mail_command = new char[1024];

      sprintf( mail_command, "mail -s \"%s\" %s < %s", (subj[0] ? subj : ""), addr_to, tmpfile );
      if ( (status=system( mail_command )) )
	 test( lang( "Mail sending error.", "   ." ) );
      ::unlink( tmpfile );
      delete mail_command;
      if ( !status )
	 test( lang( "Mail sended.", " ." ) );
    }
   return key;

bad_file:
   test( lang( "Can't create temporary file.","   ." ) );
   return 0;
}

